# RoCo backend

## Generate custom 2D patterns for papercraft, lasercutter, or wood

### Requirements

- Python 3
    - Tested on 3.7, 3.8, 3.9; use other versions at your own risk
- `pip`

### Installation for non-developer use

- (Optionally) [create a virtual environment](https://docs.python.org/3/library/venv.html)
- `pip install` the rocolib library:
    - Stable release:

        Either:

        - One-liner:

            ```
            $ pip install rocolib --extra-index-url https://git.uclalemur.com/api/v4/projects/202/packages/pypi/simple
            ```

        - or, edit your [pip configuration](https://pip.pypa.io/en/stable/user_guide/#config-file) to include or extend your `global` section:

            ```
            [global]
                extra-index-url = https://git.uclalemur.com/api/v4/projects/202/packages/pypi/simple
            ```

            then simply:

            ```
            $ pip install rocolib
            ```

    - Latest (possibly unstable) commit:

        ```
        $ pip install git+https://git.uclalemur.com/roco/rocolib#egg=rocolib
        ```

### Installation for development

```
% git clone https://git.uclalemur.com/roco/rocolib.git
% ./vstart.sh
```

`vstart.sh` creates the venv directory in `./ENV` and pip installs the requirements on first run; it launches a shell within that venv whenever run thereafter.  Editing the source code will be reflected in the rocolib modules whenever re-imported.

### Usage

If you created a virtual environment during install, enter it.  Then, you can import and use this module in scripts, the python REPL, or through the rudimentary CLI.

See [a simple tutorial](https://git.uclalemur.com/roco/tutorial) for more details on how to use RoCo.
