from dataclasses import dataclass, field
import numpy as np

@dataclass
class Material:
    name: str
    density: float = 1 # kg/m3
    rgb: np.ndarray = np.array([0, 0, 0])
    roughness: float = 1.0
    reflection: float = 0.
    optional: dict = field(default_factory=dict)
    description: str = """"""

@dataclass(frozen=True)
class MaterialConst:
    MAT_DEFAULT: str = 'defaultMaterial'



mc = MaterialConst()
materialData = {}

materialData[mc.MAT_DEFAULT] \
    = Material('generic_material', description="""This is a default material.""")

materialData['paperThick'] \
    = Material('Thick Paper', 833.3, description="""Business card paper""")
